library tags.dom;

import 'dart:async';
import 'dart:html';
import 'dart:svg' show SvgElement;
import 'tags.dart';

part 'src/custom/editable_label.dart';
part 'src/custom/toggle_button.dart';
part 'src/custom/toggle_open.dart';

const Dom TAGS_DOM = const _Dom();

class _Dom extends Dom {
  
  const _Dom();
  
  static bool _isRegistered = false;
  
  void registerElements() {
    if (!_isRegistered) {
      _isRegistered = true;
      document.register(EditableLabel.TAG, EditableLabel);
      document.register(ToggleButton.TAG, ToggleButton, extendsTag: 'button');
      document.register(ToggleOpen.TAG, ToggleOpen);
    }
  }
  
  createElement(String tag, [String typeExtention]) => 
      new Element.tag(tag, typeExtention);
  
  createSvgElement(String tag) => new SvgElement.tag(tag);
}
