library tags;

import 'dart:async';

part 'src/builder.dart';
part 'src/custom.dart';
part 'src/dom.dart';
part 'src/html.dart';
part 'src/svg.dart';
part 'src/custom/resources.dart';
part 'src/custom/themeable.dart';
part 'src/custom/toggleable.dart';

Dom _dom;
/// The current Document Object Model used by this library.
/// 
/// The [Tag] builder functions delegate to this dom to create elements and 
/// nodes.  The dom is decoupled to allow for building trees of tags without a 
/// dependency on `dart:html`. 
/// 
/// This must be set by the user of this library prior to making any other
/// calls to this library.  This will typically be set in a `main` function or
/// other bootstrapping logic.  For example:
/// 
///     import 'package:tags/tags.dart' as tags;
///     import 'package:tags/dom.dart';
///
///     main() {
///       tags.dom = TAGS_DOM;
///       ...
///     }
Dom 
  get dom => _dom;
  set dom(Dom dom) {
    _dom = dom;
    _dom.registerElements();
  }
